## TOC
- [TOC](#toc)
- [Script Overview](#script-overview)
  - [Daily-Bonus Script](#daily-bonus-script)
  - [Functionality-enhancing Script](#functionality-enhancing-script)
  - [Other Script](#other-script)
- [Surge File Overview](#surge-file-overview)
- [QuantumultX File Overview](#quantumultx-file-overview)
- [Loon File Overview](#loon-file-overview)
- [Stash File Overview](#stash-file-overview)
- [Disclaimer](#disclaimer)
  - [Decrypt](#decrypt)
  - [Privacy](#privacy)
  - [Commercial](#commercial)
  - [Infringement](#infringement)
  - [Liability](#liability)
  - [Change](#change)
- [Acknowledgment](#acknowledgment)
- [License](#license)


> **Please note that the scripts or rewrite rules described below may require MITM to be enabled, and the generated root certificate needs to be manually installed and trusted in the system.**

## Script Overview

### Daily-Bonus Script

|                       Application                       |                         Script name                          |   Available    | Maintenance |
| :-----------------------------------------------------: | :----------------------------------------------------------: | :------------: | :---------: |
|   [京东商城](https://apps.apple.com/app/id414245413)    | [JD_DailyBonus.js](https://github.com/NobyDa/Script/blob/master/JD-DailyBonus/JD_DailyBonus.js) |       ❌        |      ⚠️      |
|   [百度贴吧](https://apps.apple.com/app/id477927812)    | [TieBa.js](https://github.com/NobyDa/Script/blob/master/BDTieBa-DailyBonus/TieBa.js) | ✅ (2023/08/17) |      ❌      |
|           [吾爱破解](https://www.52pojie.cn/)           | [52pojie.js](https://github.com/NobyDa/Script/blob/master/52pojie-DailyBonus/52pojie.js) |       ❌        |      ❌      |
|   [爱奇艺](https://apps.apple.com/cn/app/id393765873)   | [iQIYI.js](https://github.com/NobyDa/Script/blob/master/iQIYI-DailyBonus/iQIYI.js) | ✅ (2023/08/17) |      ✅      |
|   [快看漫画](https://apps.apple.com/app/id906936224)    | [KKMH.js](https://github.com/NobyDa/Script/blob/master/KuaiKan-DailyBonus/KKMH.js) | ✅ (2023/08/17) |      ✅      |
| [哔哩哔哩漫画](https://apps.apple.com/app/id1426252715) | [Manga.js](https://github.com/NobyDa/Script/blob/master/Bilibili-DailyBonus/Manga.js) | ✅ (2023/08/17) |      ✅      |
|          [巴哈姆特](https://www.gamer.com.tw/)          | [BahamutDailyBonus.js](https://github.com/NobyDa/Script/blob/master/Bahamut/BahamutDailyBonus.js) | ✅ (2023/08/17) |      ✅      |

------

### Functionality-enhancing Script

| Script name                                                                                             | Description                                                                                                                                                                                                                        |
|:-------------------------------------------------------------------------------------------------------:|:----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|
| [PolicySwitch.js](https://github.com/NobyDa/Script/blob/master/Shortcuts/PolicySwitch.js)               | Switch [QX](https://apps.apple.com/app/id1443988620),[Surge](https://apps.apple.com/app/id1442620678),[Loon](https://apps.apple.com/app/id1373567447) policy groups using ios [shortcut](https://apps.apple.com/app/id1462947752). |
| [DataQuery.js](https://github.com/NobyDa/Script/blob/master/Sub-store-parser/DataQuery.js)              | Server(VPN) traffic query based on [Sub-Store](https://github.com/Peng-YM/Sub-Store).                                                                                                                                              |
| [Bili_Auto_Regions.js](https://github.com/NobyDa/Script/blob/master/Surge/JS/Bili_Auto_Regions.js)      | [Bilibili anime](https://apps.apple.com/cn/app/id736536022) auto switch region & show [douban](https://www.douban.com/) rating.                                                                                                    |
| [ExchangePoints.js](https://github.com/NobyDa/Script/blob/master/Bilibili-DailyBonus/ExchangePoints.js) | [Bilibili Comics](https://apps.apple.com/app/id1426252715) points mall auto snap up.                                                                                                                                               |
| [TestFlightAccount.js](https://github.com/NobyDa/Script/blob/master/TestFlight/TestFlightAccount.js)    | Merge and share [TestFlight](https://apps.apple.com/app/id899247664) accounts                                                                                                                                                      |
| [Google_CAPTCHA.js](https://github.com/NobyDa/Script/blob/master/Surge/JS/Google_CAPTCHA.js)            | Google CAPTCHA solution(Surge only)                                                                                                                                                                                                |

---

### Other Script

|                         Application                          |                         Script name                          |       Description       |   Available    |
| :----------------------------------------------------------: | :----------------------------------------------------------: | :---------------------: | :------------: |
|    [HTTPBot](https://apps.apple.com/cn/app/id1232603544)     | [vsco.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/vsco.js) |    Unlock membership    | ✅ (2023/08/17) |
|        [VSCO](https://apps.apple.com/app/id588013838)        | [vsco.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/vsco.js) |    Unlock membership    | ✅ (2023/08/17) |
|     [1Blocker](https://apps.apple.com/app/id1365531024)      | [vsco.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/vsco.js) |    Unlock membership    | ✅ (2023/08/17) |
|       [JibJab](https://apps.apple.com/app/id875561136)       | [jibjab.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/jibjab.js) |    Unlock membership    | ✅ (2023/08/17) |
| [美易Picsart](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/PicsArt.js) | [PicsArt.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/PicsArt.js) |    Unlock membership    | ✅ (2023/08/17) |
|    [MIX滤镜大师](https://apps.apple.com/app/id913947918)     | [MIX.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/MIX.js) | Unlock in-app purchases | ✅ (2023/08/17) |
|    [Polarr 泼辣](https://apps.apple.com/app/id988173374)     | [Polarr.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/Polarr.js) | Unlock in-app purchases | ✅ (2023/08/17) |
|   [小影VivaVideo](https://apps.apple.com/app/id738897668)    | [vivavideo.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/vivavideo.js) |    Unlock membership    | ✅ (2023/08/17) |
|     [CamScanner](https://apps.apple.com/app/id388627783)     | [CamScanner.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/CamScanner.js) |  Unlock some benefits   | ✅ (2023/08/17) |
|     [知音漫客](https://apps.apple.com/app/id1012491820)      | [Zymh.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/Zymh.js) |   Unlock vip chapters   | ✅ (2023/08/17) |
|               [香蕉视频](https://www.aa2.app)                | [xjsp.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/xjsp.js) |    Unlock membership    | ✅ (2023/08/17) |
|   [网易蜗牛读书](https://apps.apple.com/app/id1127249355)    | [wnyd.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/wnyd.js) |    Unlock membership    | ✅ (2023/08/17) |
|    [陆琪讲故事](https://apps.apple.com/app/id1435575842)     | [luqi.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/luqi.js) |      Unlock radio       | ✅ (2023/08/17) |
|      [百度网盘](https://apps.apple.com/app/id547166701)      | [BaiduCloud.js](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/JS/BaiduCloud.js) |   Unlock video speed    | ✅ (2023/08/17) |
|       [WeChat](https://apps.apple.com/app/id414478124)       | [Wechat.js](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/File/Wechat.js) |       Remove Ads        | ✅ (2023/08/17) |
|     [動畫瘋](https://apps.apple.com/tw/app/id1102650114)     | [BahamutAnimeAds.js](https://raw.githubusercontent.com/NobyDa/Script/master/Bahamut/BahamutAnimeAds.js) |       Remove Ads        | ✅ (2023/08/17) |

---

## Surge File Overview

|                          File name                           |                         Description                          | Type   |
| :----------------------------------------------------------: | :----------------------------------------------------------: | ------ |
| [HuiJuDongManAds.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/HuiJuDongManAds.sgmodule) |  Remove [APP](https://apps.apple.com/app/id1451949669) Ads   | Module |
| [IPA_install.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/IPA_install.sgmodule) |     Use Surge to assist in install IPA (signed version)      | Module |
| [TestFlightDownload.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/TestFlightDownload.sgmodule) | Remove [TestFlight](https://apps.apple.com/app/id899247664) region restrictions | Module |
| [TestFlightAccount.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/TestFlightAccount.sgmodule) | Merge and share [TestFlight](https://apps.apple.com/app/id899247664) accounts | Module |
| [GetCookie.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/GetCookie.sgmodule) |                  Daily bonus script related                  | Module |
| [BahamutAnimeAds.sgmodule](https://raw.githubusercontent.com/NobyDa/Script/master/Surge/Module/BahamutAnimeAds.sgmodule) | Remove [Bahamut anime](https://apps.apple.com/tw/app/id1102650114) Ads | Module |

---

## QuantumultX File Overview

| File name                                                                                                             | Description                                                                     | Type              |
|:---------------------------------------------------------------------------------------------------------------------:|:-------------------------------------------------------------------------------:|:-----------------:|
| [Js.conf](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/Js.conf)                                 | Remote script subscription.                                                     | Rewrite Resources |
| [Js_Remote_Cookie.conf](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/Js_Remote_Cookie.conf)     | Daily bonus script related                                                      | Rewrite Resources |
| [TestFlightDownload.conf](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/TestFlightDownload.conf) | Remove [TestFlight](https://apps.apple.com/app/id899247664) region restrictions | Rewrite Resources |
| [IPA-Installer.snippet](https://raw.githubusercontent.com/NobyDa/Script/master/QuantumultX/IPA-Installer.snippe)      | Use QX to assist in install IPA (signed version)                                | Rewrite Resources |

Rules of type "Rule" include only ad hosts. Please select the REJECT policy.

<details><summary>Difference between QuantumultX versions (Click to view)</summary>

* AppStore version QX1.0.0 (120) This version is the initial version, JS function is unlimited.

* AppStore version QX1.0.1 (130) This version adds support V2Ray(protocols), but restricts the keywords of the script VIP type.

* AppStore version QX1.0.2 (136) This version adds support HTTP(protocols) and relaxes certain script keyword restrictions, but restricts script remote subscriptions

* AppStore version QX1.0.3 (155) This version removes the keyword restriction and restores the script remote subscription, however, the remote script needs to comment the device ID before execution.

* AppStore version QX1.0.4 (164) This version completely restricts remote script subscriptions, meaning that all scripts can only use local paths.

* AppStore version QX1.0.5 (192) This version adds a timed script task function.

* AppStore version QX1.0.6 (212) This version supports modifying HTTP request body, and replaying HTTP request.

* AppStore version QX1.0.7 (240) This version supports TLS 1.3 (TLS-based proxy protocol), and Trojan(protocols).

* ...

* AppStore version QX1.0.10 (313) In this version, script remote subscription has been restored.

QX1.0.3 add device ID, a simple example:

```javascript
/**
 * @supported 23AD6B11CD4B
 */

let obj = JSON.parse($response.body)
obj["example"] = 0;
$done({body:JSON.stringify(obj)})
```

The above random generated device ID can be found at the bottom of Quantumult X additional menu, and it may change after system restore.

</details>

---

## Loon File Overview

|                          File name                           |                         Description                          |  Type  |
| :----------------------------------------------------------: | :----------------------------------------------------------: | :----: |
| [Loon_GetCookie.plugin](https://raw.githubusercontent.com/NobyDa/Script/master/Loon/Loon_GetCookie.plugin) |                  Daily bonus script related                  | Plugin |
| [Loon_TF_Download.plugin](https://raw.githubusercontent.com/NobyDa/Script/master/Loon/Loon_TF_Download.plugin) | Remove [TestFlight](https://apps.apple.com/app/id899247664) region restrictions | Plugin |
| [Loon_TF_Account.plugin](https://raw.githubusercontent.com/NobyDa/Script/master/Loon/Loon_TF_Account.plugin) | Merge and share [TestFlight](https://apps.apple.com/app/id899247664) accounts | Plugin |
| [Loon_Bahamut_ADS.plugin](https://raw.githubusercontent.com/NobyDa/Script/master/Loon/Loon_Bahamut_ADS.plugin) | Remove [Bahamut anime](https://apps.apple.com/tw/app/id1102650114) Ads | Plugin |
| [Loon_IPA_Installer.plugin](https://raw.githubusercontent.com/NobyDa/Script/master/Loon/Loon_IPA_Installer.plugin) |      Use Loon to assist in install IPA (signed version)      | Plugin |

---

## Stash File Overview

| File name                                                                                                         | Description                                         | Type     |
|:-----------------------------------------------------------------------------------------------------------------:|:---------------------------------------------------:|:--------:|
| [IPA-Installer.stoverride](https://raw.githubusercontent.com/NobyDa/Script/master/Stash/IPA-Installer.stoverride) | Use Stash to assist in install IPA (signed version) | Override |

---

## Disclaimer

Please note that in the following disclaimer, the term "Script-project"  specifically refers to the open source scripts and rules available at "https://github.com/NobyDa/Script", while the term "NobyDa" specifically refers to the author and owner of these scripts and rules.

### Decrypt

- Any scripts involved in unlocking and decrypting in the Script-project are intended for resource sharing and study purposes only. The  legality, accuracy, completeness, and validity of these scripts cannot  be guaranteed. **Therefore, please use your own judgment based on the  actual situation.**

- You are required to delete the decryption scripts from your computer or phone completely within **24 hours** of downloading them.

### Privacy

- NobyDa is not responsible for any privacy breaches or other consequences arising from the direct or indirect use of any of the scripts in the  Script-project, including but not limited to violating relevant laws  and regulations or establishing VPS for spreading purposes.

### Commercial

- Do not use any scripts from the Script-project for commercial or  illegal purposes, **otherwise, you will be responsible for the  consequences that may arise**.

### Infringement

- If any company or individual believes that any script in the Script-project may infringe on their rights, they should promptly notify us  and provide proof of **ownership** and **identity**. We will delete the relevant scripts upon receipt of the necessary documents.

### Liability

- NobyDa is not responsible for any scripts problems, **including but not limited to any loss or damage caused by any scripting errors.**

### Change

- Anyone who views or uses the scripts in the Script-project, whether  directly or indirectly, should carefully read this disclaimer. NobyDa  reserves the right to change or supplement this disclaimer at any time.

- **By viewing, using, or copying any of the related scripts in the Script-project, you will be deemed to have accepted this disclaimer.**

## Acknowledgment

* [@sazs34](https://github.com/sazs34)
* [@lhie1](https://github.com/lhie1)
* [@Scomper](https://github.com/scomper)
* [@onewayticket255](https://github.com/onewayticket255)
* [@Choler](https://github.com/Choler)
* [@ConnersHua](https://github.com/ConnersHua)

## License

[GPLv3](LICENSE)
